/*
 * PlanJBounce components are Open Source
 * PlanJBounce requires PlanJCore (not Open Source)

2023-09-26 Adjust for real life test
  OK(Remote) - CL(ThreadN) - Vect Mess
  Bad(Remote) - CL(Message) - CM(Mess) - Count
2023-10-01 incomplete reporting making synchronized....
2023-10-03 Bouncer maintains an IP based list of interactions
2023-10-11 Adding getData and Flush (eventually set a date/limit)
2023-10-13 Explicit setting of Owner and Country
2023-10-16 0.3.3 Minor fixes
2023-10-18 adapt to IPOrigin
2023-10-20 Fixed getFor / cache management
2023-10-22 adjust fetchFor - Origin vs Cache
2023-10-23 fix getOrigin again :) - 0.4.0 Add User-Agent Support
2023-10-24 add Ingest(Node) to test for BNode issue at 20Kb text

 */
package ca.planj.bounce;

/**
 * Bouncer is the static collector of Data for a Client IP
 * Bouncer instances provide a detailed view of interactions fed by httpBounce
 * @author jipi@planj.ca
 */
public class Bouncer {
    public static String Version = "PlanJBouncer 0.4.2 2023-10-24";
    public static boolean debug = false;
    
    /**
     * Not formally used - may delete
     * @param P
     * @param S
     * @param Po
     * @param Ge
     * @param St
     * @param np 
     */
    public static void setCurrent(String P, String S, boolean Po, boolean Ge, boolean St, boolean np) {
        if (debug) System.out.println("Setting " + P);
    }
    
    // Static variables, reset with Bouncer.Clients.clear();
    public static java.util.Hashtable Clients = new java.util.Hashtable(15);
    // Number of entries before summarizing data
    public static int filterSize = 6;
    
    // Caller IP based object
    String ip = null;
    int Count = 0;
    int Logged = 0;
    int Stripped = 0;
    String DNS = null;
    String UserAgent = null;
    String[] Origin = null;
    java.util.Vector Bad = new java.util.Vector(5,4);
    java.util.Vector Good = new java.util.Vector(5,4);
    
    @Override
    public String toString(){
        return ip + " " + Good.size() + "/" + Bad.size() + " " + (Origin==null?"null":Origin[2]);
    }
    
    /**
     * To reingest from old lists
     * @param N 
     */
    public static void Ingest(ca.planj.data.Node N) {
        N.Name = ca.planj.util.StringUtils.ReplaceStr(N.Name, "_", ".");
        Bouncer B = new Bouncer();
        B.ip = N.Name;
        B.DNS = (String) N.getValue("DNS");
        B.UserAgent = (String) N.getValue("UserAgent");
        B.Stripped = (int) ((long) N.getValue("Stripped"));
        String O = (String) N.getValue("Origin");
        B.Origin = new String[] { O.substring(0,O.indexOf(" ")), O.substring(O.lastIndexOf(" ")+1), O };
        java.util.Vector V = (java.util.Vector) N.getValue("Rejected");
        if (V != null) for (int i=0; i<V.size(); i++) B.Bad.addElement(V.elementAt(i));
        V = (java.util.Vector) N.getValue("Forwarded");
        if (V != null) for (int i=0; i<V.size(); i++) B.Good.addElement(V.elementAt(i));
        Clients.put(N.Name,B);
    }
    
    /**
     * Collects User-Agent info for an IP - potential for messyness
     * Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:109.0) Gecko/20100101 Firefox/118.0
     * Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/17.0 Safari/605.1.15
     * Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/117.0.0.0 Safari/537.36 Edg/117.0.2045.60
     * Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/118.0.0.0 Safari/537.36
     * @param A 
     */
    public void setUserAgent(String A) {
        if (A == null) return;
        // Work on UA Structure
        String OS = null;
        String Browser = null;
        try {
            int a = A.indexOf("(");
            int b = A.indexOf(" ",a);
            if (a > 0) if (b > a) OS = A.substring(a+1,b);
            if (OS.endsWith(";")) OS = OS.substring(0,OS.length()-1);
            int c = A.lastIndexOf(" ");
            int d = A.lastIndexOf(")");
            if (c > 0) Browser = A.substring(c+1);
            if (debug) System.out.println("SUA : " + A + "\n\tSUB : " + OS + " - " + Browser);
            if (d > -1) if (d < c) {
                String Z = A.substring(d+1,c).trim();
                if (debug) System.out.println("\tSUC : " + Z);
                if (!Z.contains(" ")) if (Z.toLowerCase().contains("chrom")) Browser = Z;
            }
        } catch (Exception y) {}        
        // Done
        if (UserAgent == null) {
            if ((OS != null) && (Browser != null)) UserAgent = OS + " " + Browser;
            else UserAgent = A;
            if (UserAgent.length() > 30) UserAgent = UserAgent.substring(0,UserAgent.indexOf(" ")) + UserAgent.substring(UserAgent.lastIndexOf(" "));
        } else {
            if (OS != null) if (!UserAgent.contains(OS)) UserAgent += " " + OS;
            if (Browser != null) if (!UserAgent.contains(Browser)) UserAgent += " " + Browser;
        }
    }
    
    /**
     * Returns the Object's Data in Node format
     * @return 
     */
    public ca.planj.data.Node getData() {
        ca.planj.data.Node C = ca.planj.data.Node.makeDataNode(ip);
        C.addChild("Origin", getOrigin()[2]);
        C.addChild("DNS", getDNS());
        if (UserAgent != null)  C.addChild("UserAgent", UserAgent);
        C.addChild("Stripped", (long) Stripped);
        if (Good.size() > 0) {
            java.util.Vector V = new java.util.Vector(Good.size()+3,2);
            ca.planj.data.Node G = C.addChild("Forwarded", V);
            for (int j=0; j<Good.size(); j++) G.addItem(Good.elementAt(j));
        }
        if (Bad.size() > 0) {
            java.util.Vector V = new java.util.Vector(Bad.size()+3,2);
            ca.planj.data.Node G = C.addChild("Rejected", V);
            for (int j=0; j<Bad.size(); j++) G.addItem(Bad.elementAt(j));
        }
        return C;
    }
    
    /**
     * Flushing all Clients
     */
    public static void Flush() {
        String[] AA = ca.planj.util.SortBox.sortKeys(Clients);
        for (int i=0; i<AA.length; i++) ((Bouncer) Clients.get(AA[i])).flush();
        Clients.clear();
        System.gc();
    }
    
    /**
     * Flushing this Bouncer Object
     */
    public void flush() {
        Bad = null;
        Good = null;
        Clients.remove(ip);
    }
    
    /**
     * Returns the FQDN of the IP (if it can be resolved)
     * @return 
     */
    public String getDNS() {
        if (DNS == null) DNS = ca.planj.ip.util.IPOrigin.getDNS(ip);
        return DNS;
    }
    
    /**
     * Return basic WHOIS info of the IP (if it can be resolved)
     * @return 
     */
    public String[] getOrigin() {
        if (Origin == null) Origin = ca.planj.ip.util.IPOrigin.fetchFor(ip);
        if (Origin[2].startsWith("Processing ")) Origin = ca.planj.ip.util.IPOrigin.fetchFor(ip);
        return Origin;
    }
    
    /**
     * Add a failed request for this IP
     * @param Message 
     */
    public void add404(String Message) {
        Bad.addElement(ca.planj.util.ISODate.getISODate() + " " + Message);
        Logged++;
    }
    
    /**
     * Add a redirected request for this IP
     * @param Message 
     */
    public void add302(String Message) {
        Good.addElement(ca.planj.util.ISODate.getISODate() + " " + Message);
        Logged++;
    }
    
    /**
     * Used to summarize long request lists
     */
    private class filter {
        int cnt = 0;
        String min = null;
        String max = null;
        
        void addDate(String D) {
            cnt++;
            if (min == null) min = D;
            else if (D.compareTo(min) < 0) min = D;
            if (max == null) max = D;
            else if (D.compareTo(max) > 0) max = D;
        }
    }
    
    /**
     * Fetch the list from here (or directly use Bouncer.Good) it will be summarized if needed
     * @return 
     */
    public java.util.Vector filterGood() {
        if (Good.size() < filterSize) return Good;
        java.util.Vector Tgt = new java.util.Vector(15,10);
        java.util.Hashtable Msg = new java.util.Hashtable(15);
        for (int i=0; i<Good.size(); i++) {
            String B = (String) Good.elementAt(i);
            String Date = B.substring(0,19);
            String Message = B.substring(20);
            // 2023-10-02 16:54:10 HostName required, not IP : /Hello2  -Bad, just URI on Good
            filter F = (filter) Msg.get(Message);
            if (F == null) {
                F = new filter();
                Msg.put(Message, F);
            }
            F.addDate(Date);
        }
        String[] Res = ca.planj.util.SortBox.sortKeys(Msg);
        for (int i=0; i<Res.length; i++) {
            filter F = (filter) Msg.get(Res[i]);
            Tgt.addElement((F.cnt>1?"(" + F.cnt + "x) ":"") + F.min + (F.cnt>1?" to " + F.max:"") + (F.cnt>1?" - ":" ") + Res[i]);
        }
        return Tgt;
    }
    
    /**
     * Fetch the list from here (or directly use Bouncer.Bad) it will be summarized if needed
     * @return 
     */
    public java.util.Vector filterBad() {
        if (Bad.size() < filterSize) return Bad;
        java.util.Vector Tgt = new java.util.Vector(15,10);
        java.util.Hashtable Msg = new java.util.Hashtable(15);
        for (int i=0; i<Bad.size(); i++) {
            String B = (String) Bad.elementAt(i);
            String Date = B.substring(0,19);
            String Message = B.substring(20);
            // 2023-10-02 16:54:10 HostName required, not IP : /Hello2  -Bad, just URI on Good
            filter F = (filter) Msg.get(Message);
            if (F == null) {
                F = new filter();
                Msg.put(Message, F);
            }
            F.addDate(Date);
        }
        String[] Res = ca.planj.util.SortBox.sortKeys(Msg);
        for (int i=0; i<Res.length; i++) {
            filter F = (filter) Msg.get(Res[i]);
            Tgt.addElement((F.cnt>1?"(" + F.cnt + "x) ":"") + F.min + (F.cnt>1?" to " + F.max:"") + (F.cnt>1?" - ":" ") + Res[i]);
        }
        return Tgt;
    }
    
    /**
     * Returns a Bouncer object if it exists for the IP
     * @param IP
     * @return 
     */
    public static Bouncer getFor(String IP) {
        Bouncer res = (Bouncer) Clients.get(IP);
        if (debug) System.out.println("** Bouncer " + IP + " -> " + res);
        if (res == null) {
            //String[] X = ca.planj.ip.util.IPOrigin.fetchFor(IP);
            //ca.planj.ip.util.origin.queue(IP);
            res = new Bouncer();
            res.ip = IP;
            res.Origin = ca.planj.ip.util.IPOrigin.fetchFor(IP);
            Clients.put(IP, res);
        }
        if (res.Origin[2].startsWith("Processing")) res.Origin = ca.planj.ip.util.IPOrigin.fetchFor(IP);
        if (debug) System.out.println("-- Bouncer " + IP + " -> " + res);
        // res.Count++; // not here, increments every time we read data
        return res;
    }
    
}
