/*
 * Override default whois IPOrigin
2023-10-21 Working, might need a Fields Override Parameter
 */
package ca.planj.bounce.origin;

/**
 * BigDataCloud.net IPOrigin resolver - requires a Key / account
 * @author jipi@planj.ca
 */
public class BigDataCloud extends ca.planj.ip.util.IPOrigin {
    public static String Version = "PlanJ IPOrigin for BigDataCloud 0.1.0 2023-10-19";
    public static boolean debug = false;

    String API = "https://api.bigdatacloud.net/data/ip-geolocation?ip=[IP]&localityLanguage=en&key=[key]";
    String Key = "<!$BDCAPI_key$!>";
    //https://api.bigdatacloud.net/data/ip-geolocation?ip=24.139.8.186&localityLanguage=en&key=bdc_3671153879184b488acb302114978cb5

    // Country ID first (will be applied last), then sequence to build the String
    String[] Fields = { "country.isoAlpha2", "network.carriers[0].name", "network.organisation", "location.city", "location.principalSubdivision" };
    
    @Override
    public ori process(String IP) {
        ori A = new ori();
        A.V = new String[] { "-Unknown-","ZZ","Stub for " + IP + " ZZ" };
        try {
            String Req = ca.planj.util.StringUtils.ReplaceStr(API, "[IP]", IP);
            Req = ca.planj.util.StringUtils.ReplaceStr(Req, "[key]", Key);
            if (debug) logDebug(Req);
            //System.out.println(Req);
            String Z = ca.planj.util.QuickRead.readWeb(Req, null); //ca.planj.com.handle.httpClient.getString(Req);
            ca.planj.data.Node N = ca.planj.data.nodeio.JSonIO.getInstance().ingestChild(Z);
            for (int i=0; i<Fields.length; i++) {
                Object O = N.getValue(Fields[i]);
                if (O != null) {
                    if (i == 0) {
                        A.V[1] = (String) O;
                        A.V[2] = "";
                    } else A.V[2] += O + " ";
                }
            }
            A.V[2] += A.V[1];
            A.V[0] = A.V[2].substring(0,A.V[2].indexOf(" "));
            if (A.V[0].contains("-")) A.V[0] = A.V[0].substring(0,A.V[0].indexOf("-"));
            if (A.V[0].contains("_")) A.V[0] = A.V[0].substring(0,A.V[0].indexOf("_"));
            Health = 1;
        } catch (Exception u) {
            Health = 0;
            u.printStackTrace();
        }        
        return A;
    }
    
    @Override
    public String getV() {
        return Version;
    }
    
    @Override
    public boolean enable(ca.planj.data.Node N) {
        super.enable(N);
        //System.out.println("Enable " + this);
        if (N.getChild("API") != null) API = (String) N.getValue("API");
        if (N.getChild("Key") != null) {
            Key = (String) N.getValue("Key");
            if (Key.contains("BDCAPI")) {
                logErr("BigDataCloud origin resolution has unresolved secret API key");
                disable();
                return false;
            }
            Health = 1;
        } else {
            logErr("BigDataCloud origin resolution requires an API key");
            disable();
            return false;
        }
        return true;
    }
    
    @Override
    public ca.planj.data.Node coreParams() {
        ca.planj.data.Node D = super.coreParams();
        D.addChild("Key", new String[] { "String","Required","Your personal access key" });
        D.addChild("API", new String[] { "String","Optional","API URL with [IP] and [key] placeholders"});
        // Plan for Fields List
        return D;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        ca.planj.data.Node N = ca.planj.data.nodeio.JSonIO.getInstance().ingestChild(myData);
        //ca.planj.data.nodeio.JSonIO.getInstance().full = false;
        System.out.println(ca.planj.data.nodeio.JSonIO.getInstance().format(N));
        System.exit(0);
        
        BigDataCloud A = new BigDataCloud();
        String[] TGT = { "127.0.0.1", "43.139.2.70", "193.32.162.174", "1.14.94.175", "124.66.76.117", "138.0.172.244", "179.43.163.130", "43.134.71.15", "52.167.144.54", "51.222.253.20", "178.79.146.29", "45.95.168.217", "194.38.22.71", "24.139.8.186" }; 
        // TGT = new String[] { "124.66.76.117", "138.0.172.244" };
        
        ca.planj.boot.Configure.loadJSon(IPO);
        //ca.planj.bounce.Bouncer.debug = true;
        //ca.planj.ip.util.IPOrigin.debug = true;
        //debug = true;
        
        for (int i=0; i<TGT.length; i++) {
            ca.planj.bounce.Bouncer Z = ca.planj.bounce.Bouncer.getFor(TGT[i]);
            System.out.println(TGT[i] + " " + Z);
        }
        System.out.println("---------------------------------------------------------");
        try { Thread.currentThread().sleep(1500); } catch (Exception u) {}
        
        for (String TGT1 : TGT) {
            ca.planj.bounce.Bouncer Z = ca.planj.bounce.Bouncer.getFor(TGT1);
            System.out.println(TGT1 + " " + Z);
        }
        
        /*
        // 2023-10-19 JSON ingest Se perd dans la liste de location.localityInfo.administrative
        // Environ ligne 1885
        // Adminitsrative est une liste d'une série de Nodes - pas juste un.. possiblement un Node[] à mettre en place
        // Aussi, il faudrait voir à mettre dans dans getChild et GetValue une façon de récupérer un Index
        
        //ca.planj.data.nodeio.JSonIO.debug = true;
        ca.planj.data.Node N = ca.planj.data.nodeio.JSonIO.getInstance().ingestChild(myData);
        System.out.println("INfo ----------\n"); // + N.describe(false));
        System.out.println("Co " + N.getValue("country.isoAlpha2"));
        System.out.println("Pr " + N.getValue("location.principalSubdivision"));
        System.out.println("Ci " + N.getValue("location.city"));
        System.out.println("Ne " + N.getValue("network.organisation"));
        ca.planj.data.Node[] C = (ca.planj.data.Node[]) N.getChild("network.carriers").getItem(0);
        // Could be structured as network.carriers[0].name 
        for (int i=0; i<C.length; i++) if (C[i].Name.equals("name")) System.out.println("Cr " + C[i].Value);
        System.out.println("Nx " + N.getValue("network.carriers[0].name"));
        //System.out.println(C + " ::: " + C[0]);
        //System.out.println("Cr " + C[0].getValue("name"));
        //System.out.println(ca.planj.data.nodeio.JSonIO.getInstance().format(N));
127.0.0.1 127.0.0.1 0/0 Loopback_IP (LAN)
43.139.2.70 43.139.2.70 0/0 TENCENT-NET-AP Tencent Cloud Computing (Beijing) Co., Ltd Shenzhen Guangdong Sheng CN
193.32.162.174 193.32.162.174 0/0 UNMANAGED-DEDICATED-SERVERS PPTECHNOLOGY LIMITED Remetea Mare Timis RO
1.14.94.175 1.14.94.175 0/0 TENCENT-NET-AP Tencent cloud computing (Beijing) Co., Ltd. Floo.. Chengdu Sichuan Sheng CN
124.66.76.117 124.66.76.117 0/0 CHINA169-Backbone China Unicom Hainan province network China Unico.. Haikou Hainan Sheng CN
138.0.172.244 138.0.172.244 0/0 Private Use AS JustWeb Telecomunicações LTDA Belo Horizonte Minas Gerais BR
179.43.163.130 179.43.163.130 0/0 PLI-AS PRIVATE LAYER INC Zurich Kanton Zurich CH
43.134.71.15 43.134.71.15 0/0 TENCENT-NET-AP-CN 6 COLLYER QUAY South Tangerang Banten ID
52.167.144.54 52.167.144.54 0/0 MICROSOFT-CORP-MSN-AS-BLOCK Microsoft Corporation District 7 Virginia US
51.222.253.20 51.222.253.20 0/0 OVH Dmytro, Ahrefs Pte Ltd Paris Ile-de-France FR
178.79.146.29 178.79.146.29 0/0 AKAMAI-LINODE-AP Linode, LLC Maidenhead England GB
45.95.168.217 45.95.168.217 0/0 MAXKO MAXKO d.o.o. Tehran Tehran Province IR
194.38.22.71 194.38.22.71 0/0 NTSERVICE-AS Rices Privately owned enterprise Kyiv Kyiv UA
24.139.8.186 24.139.8.186 0/0 EASTLINK-HSI Persona Communications Inc. South Frontenac Ontario CA        
        */
        System.exit(0);
    }
    static String IPO = "{    \"IPO\": {\n" +
"        \"Class\": \"ca.planj.bounce.origin.BigDataCloud\",\n" +
"        \"API\": \"https://api.bigdatacloud.net/data/ip-geolocation?ip=[IP]&localityLanguage=en&key=[key]\",\n" +
"        \"Key\": \"<!$BDCAPI_key$!>\",\n" +
"    }\n}";


    
// Sample Data    
    static String myData = "{\n" +
"  \"ip\": \"24.139.8.186\",\n" +
"  \"localityLanguageRequested\": \"en\",\n" +
"  \"isReachableGlobally\": true,\n" +
"  \"country\": {\n" +
"    \"isoAlpha2\": \"CA\",\n" +
"    \"isoAlpha3\": \"CAN\",\n" +
"    \"m49Code\": 124,\n" +
"    \"name\": \"Canada\",\n" +
"    \"isoName\": \"Canada\",\n" +
"    \"isoNameFull\": \"Canada\",\n" +
"    \"isoAdminLanguages\": [\n" +
"      {\n" +
"        \"isoAlpha3\": \"eng\",\n" +
"        \"isoAlpha2\": \"en\",\n" +
"        \"isoName\": \"English\",\n" +
"        \"nativeName\": \"English\"\n" +
"      },\n" +
"      {\n" +
"        \"isoAlpha3\": \"fra\",\n" +
"        \"isoAlpha2\": \"fr\",\n" +
"        \"isoName\": \"French\",\n" +
"        \"nativeName\": \"français\"\n" +
"      }\n" +
"    ],\n" +
"    \"unRegion\": \"Europe and Northern America/Northern America\",\n" +
"    \"currency\": {\n" +
"      \"numericCode\": 124,\n" +
"      \"code\": \"CAD\",\n" +
"      \"name\": \"Canadian Dollar\",\n" +
"      \"minorUnits\": 2\n" +
"    },\n" +
"    \"wbRegion\": {\n" +
"      \"id\": \"NAC\",\n" +
"      \"iso2Code\": \"XU\",\n" +
"      \"value\": \"North America\"\n" +
"    },\n" +
"    \"wbIncomeLevel\": {\n" +
"      \"id\": \"HIC\",\n" +
"      \"iso2Code\": \"XD\",\n" +
"      \"value\": \"High income\"\n" +
"    },\n" +
"    \"callingCode\": \"1\",\n" +
"    \"countryFlagEmoji\": \"🇨🇦\",\n" +
"    \"wikidataId\": \"Q16\",\n" +
"    \"geonameId\": 6251999,\n" +
"    \"isIndependent\": true\n" +
"  },\n" +
/**/"  \"location\": {\n" +  
"    \"principalSubdivision\": \"Ontario\",\n" +
"    \"isoPrincipalSubdivision\": \"Ontario\",\n" +
"    \"isoPrincipalSubdivisionCode\": \"CA-ON\",\n" +
"    \"continent\": \"North America\",\n" +
"    \"continentCode\": \"NA\",\n" +
"    \"city\": \"South Frontenac\",\n" +
"    \"localityName\": \"Loughborough\",\n" +
"    \"postcode\": \"\",\n" +
"    \"latitude\": 44.38,\n" +
"    \"longitude\": -76.6,\n" +
"    \"plusCode\": \"87P59CJ2+22\",\n" +
"    \"csdCode\": \"3510020\",\n" +
"    \"timeZone\": {\n" +
"      \"ianaTimeId\": \"America/Toronto\",\n" +
"      \"displayName\": \"(UTC-05:00) Eastern Time (Toronto)\",\n" +
"      \"effectiveTimeZoneFull\": \"Eastern Daylight Time\",\n" +
"      \"effectiveTimeZoneShort\": \"EDT\",\n" +
"      \"utcOffsetSeconds\": -14400,\n" +
"      \"utcOffset\": \"-04\",\n" +
"      \"isDaylightSavingTime\": true,\n" +
"      \"localTime\": \"2023-10-19T20:08:16.3433650\"\n" +
"    },\n" +
"    \"localityInfo\": {\n" +
"      \"administrative\": [\n" +
"        {\n" +
"          \"name\": \"Canada\",\n" +
"          \"description\": \"country in North America\",\n" +
"          \"isoName\": \"Canada\",\n" +
"          \"order\": 2,\n" +
"          \"adminLevel\": 2,\n" +
"          \"isoCode\": \"CA\",\n" +
"          \"wikidataId\": \"Q16\",\n" +
"          \"geonameId\": 6251999\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"Ontario\",\n" +
"          \"description\": \"province of Canada\",\n" +
"          \"isoName\": \"Ontario\",\n" +
"          \"order\": 5,\n" +
"          \"adminLevel\": 4,\n" +
"          \"isoCode\": \"CA-ON\",\n" +
"          \"wikidataId\": \"Q1904\",\n" +
"          \"geonameId\": 6093943\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"Eastern Ontario\",\n" +
"          \"description\": \"secondary region in Ontario, Canada\",\n" +
"          \"order\": 6,\n" +
"          \"adminLevel\": 5,\n" +
"          \"wikidataId\": \"Q3058779\"\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"Frontenac County\",\n" +
"          \"description\": \"county in Ontario, Canada\",\n" +
"          \"order\": 8,\n" +
"          \"adminLevel\": 6,\n" +
"          \"wikidataId\": \"Q739928\",\n" +
"          \"geonameId\": 5958506\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"South Frontenac\",\n" +
"          \"description\": \"township municipality in Frontenac County, Ontario, Canada\",\n" +
"          \"order\": 9,\n" +
"          \"adminLevel\": 8,\n" +
"          \"wikidataId\": \"Q4116649\",\n" +
"          \"geonameId\": 6152157\n" +
"        }\n" +
"      ],\n" +
"      \"informative\": [\n" +
"        {\n" +
"          \"name\": \"North America\",\n" +
"          \"description\": \"continent\",\n" +
"          \"isoName\": \"North America\",\n" +
"          \"order\": 1,\n" +
"          \"isoCode\": \"NA\",\n" +
"          \"wikidataId\": \"Q49\",\n" +
"          \"geonameId\": 6255149\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"America/Toronto\",\n" +
"          \"description\": \"time zone\",\n" +
"          \"order\": 3\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"Central Lowlands\",\n" +
"          \"order\": 4\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"Lanark—Frontenac—Kingston\",\n" +
"          \"description\": \"federal electoral district of Canada\",\n" +
"          \"order\": 7,\n" +
"          \"wikidataId\": \"Q16976721\"\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"Loughborough\",\n" +
"          \"order\": 10\n" +
"        },\n" +
"        {\n" +
"          \"name\": \"3510020\",\n" +
"          \"description\": \"CSD code\",\n" +
"          \"order\": 11\n" +
"        }\n" +
"      ]\n" +
"    }\n" +
"  },\n" +
"  \"lastUpdated\": \"2023-10-18T02:57:45.5039109Z\",\n" +
"  \"network\": {\n" +
"    \"registry\": \"ARIN\",\n" +
"    \"registryStatus\": \"assigned\",\n" +
"    \"registeredCountry\": \"CA\",\n" +
"    \"registeredCountryName\": \"Canada\",\n" +
"    \"organisation\": \"Persona Communications Inc.\",\n" +
"    \"isReachableGlobally\": true,\n" +
"    \"isBogon\": false,\n" +
"    \"bgpPrefix\": \"24.139.0.0/19\",\n" +
"    \"bgpPrefixNetworkAddress\": \"24.139.0.0\",\n" +
"    \"bgpPrefixLastAddress\": \"24.139.31.255\",\n" +
"    \"totalAddresses\": 8192,\n" +
"    \"carriers\": [\n" +
"      {\n" +
"        \"asn\": \"AS11260\",\n" +
"        \"asnNumeric\": 11260,\n" +
"        \"organisation\": \"EastLink\",\n" +
"        \"name\": \"EASTLINK-HSI\",\n" +
"        \"registry\": \"Arin\",\n" +
"        \"registeredCountry\": \"CA\",\n" +
"        \"registeredCountryName\": \"Canada\",\n" +
"        \"registrationDate\": \"1998-06-04\",\n" +
"        \"registrationLastChange\": \"2012-03-02\",\n" +
"        \"totalIpv4Addresses\": 596540,\n" +
"        \"totalIpv4Prefixes\": 139,\n" +
"        \"totalIpv4BogonPrefixes\": 0,\n" +
"        \"totalIpv6Prefixes\": 6,\n" +
"        \"totalIpv6BogonPrefixes\": 0,\n" +
"        \"rank\": 537,\n" +
"        \"rankText\": \"#537 out of 76,358\"\n" +
"      }\n" +
"    ],\n" +
"    \"viaCarriers\": [\n" +
"      {\n" +
"        \"asn\": \"AS1299\",\n" +
"        \"asnNumeric\": 1299,\n" +
"        \"organisation\": \"Arelion Sweden AB\",\n" +
"        \"name\": \"TWELVE99\",\n" +
"        \"registry\": \"Ripe\",\n" +
"        \"registeredCountry\": \"SE\",\n" +
"        \"registeredCountryName\": \"Sweden\",\n" +
"        \"totalIpv4Addresses\": 228330,\n" +
"        \"rank\": 1045,\n" +
"        \"rankText\": \"#1,045 out of 76,358\"\n" +
"      },\n" +
"      {\n" +
"        \"asn\": \"AS174\",\n" +
"        \"asnNumeric\": 174,\n" +
"        \"organisation\": \"Cogent Communications\",\n" +
"        \"name\": \"COGENT-174\",\n" +
"        \"registry\": \"Arin\",\n" +
"        \"registeredCountry\": \"US\",\n" +
"        \"registeredCountryName\": \"United States of America (the)\",\n" +
"        \"totalIpv4Addresses\": 19118611,\n" +
"        \"rank\": 19,\n" +
"        \"rankText\": \"#19 out of 76,358\"\n" +
"      },\n" +
"      {\n" +
"        \"asn\": \"AS3356\",\n" +
"        \"asnNumeric\": 3356,\n" +
"        \"organisation\": \"Level 3 Parent, LLC\",\n" +
"        \"name\": \"LEVEL3\",\n" +
"        \"registry\": \"Arin\",\n" +
"        \"registeredCountry\": \"US\",\n" +
"        \"registeredCountryName\": \"United States of America (the)\",\n" +
"        \"totalIpv4Addresses\": 28265629,\n" +
"        \"rank\": 14,\n" +
"        \"rankText\": \"#14 out of 76,358\"\n" +
"      },\n" +
"      {\n" +
"        \"asn\": \"AS6461\",\n" +
"        \"asnNumeric\": 6461,\n" +
"        \"organisation\": \"Zayo Bandwidth\",\n" +
"        \"name\": \"ZAYO-6461\",\n" +
"        \"registry\": \"Arin\",\n" +
"        \"registeredCountry\": \"US\",\n" +
"        \"registeredCountryName\": \"United States of America (the)\",\n" +
"        \"totalIpv4Addresses\": 1396897,\n" +
"        \"rank\": 301,\n" +
"        \"rankText\": \"#301 out of 76,358\"\n" +
"      },\n" +
"      {\n" +
"        \"asn\": \"AS8966\",\n" +
"        \"asnNumeric\": 8966,\n" +
"        \"organisation\": \"EMIRATES TELECOMMUNICATIONS GROUP COMPANY (ETISA..\",\n" +
"        \"name\": \"Etisalat-AS\",\n" +
"        \"registry\": \"Ripe\",\n" +
"        \"registeredCountry\": \"AE\",\n" +
"        \"registeredCountryName\": \"United Arab Emirates (the)\",\n" +
"        \"totalIpv4Addresses\": 16371,\n" +
"        \"rank\": 7410,\n" +
"        \"rankText\": \"#7,410 out of 76,358\"\n" +
"      }\n" +
"    ]\n" +
"  }\n" +
"}";
}
