/*
 * Override default whois IPOrigin
2023-10-19 Working, might need a Fields Override Parameter
    In Production, OK, 0.1.2 reversed region and city, added disable if invalid key
2023-10-24 Able to fetch remaining Credits
 */
package ca.planj.bounce.origin;

/**
 * IPRegistry.co IPOrigin resolver - requires a Key / account
 * @author jipi@planj.ca
 */
public class IPRegistry extends ca.planj.ip.util.IPOrigin {
    public static String Version = "PlanJ IPOrigin for ipregistry.co 0.1.2 2023-10-19";
    public static boolean debug = false;

    String API = "https://api.ipregistry.co/[IP]?key=[key]";
    String Key = "Stub";
    
    /**
     * Country ID first (will be applied last), then sequence to build the String
     */
    String[] Fields = { "location.country.code", "company.domain", "company.name", "location.city", "location.region.name" };
    
    @Override
    public ori process(String IP) {
        ori A = new ori();
        A.V = new String[] { "-Unknown-","ZZ","Stub for " + IP + " ZZ" };
        try {
            String Req = ca.planj.util.StringUtils.ReplaceStr(API, "[IP]", IP);
            Req = ca.planj.util.StringUtils.ReplaceStr(Req, "[key]", Key);
            if (debug) {
                //System.out.println(Req);
                logDebug(Req);
            }
            ca.planj.com.handle.httpData H = ca.planj.com.handle.httpClient.getComplete(Req);
            // System.out.println(H.Heads.get("ipregistry-credits-remaining")); // Credit info on IPRegistry
            String Z = H.getString();
            //String Z = ca.planj.com.handle.httpClient.getString(Req);//ca.planj.util.QuickRead.readWeb(Req, null); //
            ca.planj.data.Node N = ca.planj.data.nodeio.JSonIO.getInstance().ingestChild(Z);
            for (int i=0; i<Fields.length; i++) {
                Object O = N.getValue(Fields[i]);
                if (O != null) {
                    if (i == 0) {
                        A.V[1] = (String) O;
                        A.V[2] = "";
                    } else A.V[2] += O + " ";
                }
            }
            A.V[2] += A.V[1];
            A.V[0] = A.V[2].substring(0,A.V[2].indexOf(" "));
            if (A.V[0].contains("-")) A.V[0] = A.V[0].substring(0,A.V[0].indexOf("-"));
            if (A.V[0].contains("_")) A.V[0] = A.V[0].substring(0,A.V[0].indexOf("_"));
            Health = 1;
        } catch (Exception u) {
            logErr("IPRegistry origin resolution failed, probably bad API key " + u);
            Health = 0;
            disable();
            if (debug) u.printStackTrace();
        }        
        return A;
    }
    
    @Override
    public String getV() {
        return Version;
    }
    
    @Override
    public boolean enable(ca.planj.data.Node N) {
        super.enable(N);
        //System.out.println("Enable " + this);
        if (N.getChild("API") != null) API = (String) N.getValue("API");
        if (N.getChild("Key") != null) {
            Key = (String) N.getValue("Key");
            if (Key.contains("IPREG")) {
                logErr("IPRegistry origin resolution has unresolved secret API key");
                disable();
                return false;
            }
            Health = 1;
        } else {
            logErr("IPRegistry origin resolution requires an API key");
            disable();
            return false;
        }
        return true;
    }
    
    @Override
    public ca.planj.data.Node coreParams() {
        ca.planj.data.Node D = super.coreParams();
        D.addChild("Key", new String[] { "String","Required","Your personal access key" });
        D.addChild("API", new String[] { "String","Optional","API URL with [IP] and [key] placeholders"});
        // Plan for Fields List
        return D;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        IPRegistry A = new IPRegistry();
        String[] TGT = { "127.0.0.1", "43.139.2.70", "193.32.162.174", "1.14.94.175", "124.66.76.117", "138.0.172.244", "179.43.163.130", "43.134.71.15", "52.167.144.54", "51.222.253.20", "178.79.146.29", "45.95.168.217", "194.38.22.71", "24.139.8.186" }; 
        TGT = new String[] { "124.66.76.117", "138.0.172.244" };
        
        ca.planj.boot.Configure.loadJSon(IPO);
        //ca.planj.bounce.Bouncer.debug = true;
        //ca.planj.ip.util.IPOrigin.debug = true;
        //debug = true;
        
        for (int i=0; i<TGT.length; i++) {
            ca.planj.bounce.Bouncer Z = ca.planj.bounce.Bouncer.getFor(TGT[i]);
            System.out.println(TGT[i] + " " + Z);
        }
        System.out.println("---------------------------------------------------------");
        try { Thread.currentThread().sleep(1500); } catch (Exception u) {}
        
        for (String TGT1 : TGT) {
            ca.planj.bounce.Bouncer Z = ca.planj.bounce.Bouncer.getFor(TGT1);
            System.out.println(TGT1 + " " + Z);
        }
        
        System.exit(0);
/*
127.0.0.1 127.0.0.1 0/0 Loopback_IP (LAN)
43.139.2.70 43.139.2.70 0/0 tencent.com Tencent Cloud Computing (beijing) Co., LTD Guangzhou Guangdong Sheng CN
193.32.162.174 193.32.162.174 0/0 dmzhost.co Pptechnology Limited Amsterdam Noord-Holland NL
1.14.94.175 1.14.94.175 0/0 cnnic.cn Tencent Cloud Computing (beijing) Co., Ltd. Beijing Beijing Shi CN
124.66.76.117 124.66.76.117 0/0 chinaunicom.com China Unicom Hainan Province Network Haikou Hainan Sheng CN
138.0.172.244 138.0.172.244 0/0 Justweb Telecomunicações LTDA Ribeirão das Neves Minas Gerais BR
179.43.163.130 179.43.163.130 0/0 privatelayer.com Private Layer INC Zurich Zürich CH
43.134.71.15 43.134.71.15 0/0 tencent.com 6 Collyer Quay Singapore SG
52.167.144.54 52.167.144.54 0/0 microsoft.com Microsoft Corporation Boydton Virginia US
51.222.253.20 51.222.253.20 0/0 Dmytro, Ahrefs Pte LTD Singapore (Downtown Core) SG
178.79.146.29 178.79.146.29 0/0 linode.com Linode, LLC London England GB
45.95.168.217 45.95.168.217 0/0 maxko-hosting.com Maxko D.O.O. Sisak Sisačko-moslavačka županija HR
194.38.22.71 194.38.22.71 0/0 ntup.net Rices Privately Owned Enterprise Dnipro Dnipropetrovska oblast UA
24.139.8.186 24.139.8.186 0/0 eastlink.ca Persona Communications Inc. Verona Ontario CA        
        */        
    }
    
// Sample Item
    static String IPO = "{    \"IPO\": {\n" +
"        \"Class\": \"ca.planj.bounce.origin.IPRegistry\",\n" +
"        \"API\": \"https://api.ipregistry.co/[IP]?key=[key]\",\n" +
"        \"Key\": \"<!$IPREG_Key$!>\",\n" +
"    }\n}";

    
// Sample Data    
    static String myData = "{\"ip\":\"24.139.8.186\",\"type\":\"IPv4\",\"hostname\":null,\"carrier\":{\"name\":null,\"mcc\":null,\"mnc\":null},\"company\":{\"domain\":\"eastlink.ca\",\"name\":\"Persona Communications Inc.\",\"type\":\"isp\"},"+
            "\"connection\":{\"asn\":null,\"domain\":null,\"organization\":null,\"route\":null,\"type\":null},\"currency\":{\"code\":\"CAD\",\"name\":\"Canadian Dollar\",\"name_native\":\"Canadian Dollar\",\"plural\":\"Canadian dollars\",\"plural_native\":\"Canadian dollars\",\"symbol\":\"CA$\",\"symbol_native\":\"$\",\"format\":{\"negative\":{\"prefix\":\"-$\",\"suffix\":\"\"},\"positive\":{\"prefix\":\"$\",\"suffix\":\"\"}}},"+
            "\"location\":{\"continent\":{\"code\":\"NA\",\"name\":\"North America\"},"+
            "\"country\":{\"area\":9984670,\"borders\":[\"US\"],\"calling_code\":\"1\",\"capital\":\"Ottawa\",\"code\":\"CA\",\"name\":\"Canada\",\"population\":38929902,\"population_density\":3.9,\"flag\":{\"emoji\":\"\\uD83C\\uDDE8\\uD83C\\uDDE6\",\"emoji_unicode\":\"U+1F1E8 U+1F1E6\",\"emojitwo\":\"https://cdn.ipregistry.co/flags/emojitwo/ca.svg\",\"noto\":\"https://cdn.ipregistry.co/flags/noto/ca.png\",\"twemoji\":\"https://cdn.ipregistry.co/flags/twemoji/ca.svg\",\"wikimedia\":\"https://cdn.ipregistry.co/flags/wikimedia/ca.svg\"},"+
            "\"languages\":[{\"code\":\"en\",\"name\":\"English\",\"native\":\"English\"},{\"code\":\"fr\",\"name\":\"French\",\"native\":\"français\"},{\"code\":\"iu\",\"name\":\"Inuktitut\",\"native\":\"Inuktitut\"}],"+
            "\"tld\":\".ca\"},\"region\":{\"code\":\"CA-ON\",\"name\":\"Ontario\"},\"city\":\"Verona\",\"postal\":\"K0H\",\"latitude\":44.4791,\"longitude\":-76.69144,\"language\":{\"code\":\"en\",\"name\":\"English\",\"native\":\"English\"},\"in_eu\":false},\"security\":{\"is_abuser\":false,\"is_attacker\":false,\"is_bogon\":false,\"is_cloud_provider\":false,\"is_proxy\":false,\"is_relay\":false,\"is_tor\":false,\"is_tor_exit\":false,\"is_vpn\":false,\"is_anonymous\":false,\"is_threat\":false},\"time_zone\":{\"id\":\"America/Toronto\",\"abbreviation\":\"EST\",\"current_time\":\"2023-10-18T15:54:46-04:00\",\"name\":\"Eastern Standard Time\",\"offset\":-14400,\"in_daylight_saving\":true}}";
}
